﻿////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Quick_Fx_Palette      by Fred CRETET
//  This script apply effects ( my "favorite" ) with button bar like Fusion or Nuke
// fcretet aaat gmail dooot com
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
{
   var myPanel;

   function Quick_fx_palette(thisObj) {
      myPanel = (thisObj instanceof Panel) ? thisObj : new Window("palette", "Fx_palette", [100, 100, 300, 300]);
      //Jeff Almasol's solution to fix text color
      var winGfx = myPanel.graphics;
      var darkColorBrush = winGfx.newPen(winGfx.BrushType.SOLID_COLOR, [0,0,0], 1);

     myPanel.butFastBlur = myPanel.add("button", [10, 5, 50, 25], "F BL");
	 myPanel.butGausBlur = myPanel.add("button", [60, 5, 100, 25], "G BL");
	 myPanel.butRadialFastBlur = myPanel.add("button", [110, 5, 150, 25], "R F BL");
	 myPanel.butReduceInterlaceFliker = myPanel.add("button", [160, 5, 200, 25], "R I F");
	 
	 myPanel.sep = myPanel.add("staticText", [210, 10, 220, 25], "|");	 
	 
	 myPanel.butLevel = myPanel.add("button", [225, 5, 265, 25], "LVL");
	 myPanel.butHueSat = myPanel.add("button", [275, 5, 315, 25], "H S");
	 myPanel.butCurves = myPanel.add("button", [325, 5, 365, 25], "CRV");
	 myPanel.butTint = myPanel.add("button", [375, 5, 415, 25], "TNT");
	 
	 myPanel.sep2 = myPanel.add("staticText", [425, 10, 435, 25], "|");	 
	 
	 myPanel.butKeylight = myPanel.add("button", [440, 5, 480, 25], "KYL");
	 myPanel.butExtract = myPanel.add("button", [490, 5, 530, 25], "ETT");
	 myPanel.butInvert = myPanel.add("button", [540, 5, 580, 25], "INV");
	 myPanel.butMatteChocker = myPanel.add("button", [590, 5, 630, 25], "M CK");
	 myPanel.butSimpleChocker = myPanel.add("button", [640, 5, 680, 25], "S CK");
	 
	 myPanel.sep3 = myPanel.add("staticText", [690, 10, 695, 25], "|");	 
	 
	 myPanel.butGlow = myPanel.add("button", [705, 5, 745, 25], "GLW");
	 myPanel.butFill = myPanel.add("button", [755, 5, 795, 25], "FLL");	 
	 myPanel.butRamp = myPanel.add("button", [805, 5, 845, 25], "RMP");
	 myPanel.butFractNoise = myPanel.add("button", [855, 5, 895, 25], "FT N");
	 myPanel.butTurbulentDisplace = myPanel.add("button", [905, 5, 945, 25], "T DP");
	 
      myPanel.butFastBlur.onClick = FastBlur;
	 myPanel.butGausBlur.onClick = GaussianBlur;
	 myPanel.butRadialFastBlur.onClick = RadialFastBlur;
	 myPanel.butReduceInterlaceFliker.onClick = ReduceInterlaceFliker;
	 
	 myPanel.butLevel.onClick = Level;
	 myPanel.butHueSat.onClick = HueSat;
	 myPanel.butCurves.onClick = Curves; 
	 myPanel.butTint.onClick = Tint;
	 
	 myPanel.butKeylight.onClick = Keylight;
	 myPanel.butExtract.onClick = Extract;
	 myPanel.butInvert.onClick = Invert; 
	 myPanel.butMatteChocker.onClick = MatteChocker; 
	 myPanel.butSimpleChocker.onClick = SimpleChocker;
	 
	 myPanel.butGlow.onClick = Glow;
	 myPanel.butFill.onClick = Fill;
	 myPanel.butRamp.onClick= Ramp;
	 myPanel.butFractNoise.onClick= FractNoise;
	 myPanel.butTurbulentDisplace.onClick = TurbulentDisplace;
	 
      return myPanel;
   }
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function FastBlur(){
	app.beginUndoGroup("FastBlur");
	if ((app.project.activeItem == null) || ((app.project.activeItem != null) && !(app.project.activeItem instanceof CompItem)))
		{
		}
	else
		{
				var comp = app.project.activeItem;
				var layerCollection = comp.selectedLayers;
				for (idx=0;idx<layerCollection.length;idx++)
					{
						layerCollection[idx].Effects.addProperty("Fast Blur").property("Blurriness").setValue(9);
					}
		}
	app.endUndoGroup();
}	
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function GaussianBlur(){
	app.beginUndoGroup("GaussianBlur");
	if ((app.project.activeItem == null) || ((app.project.activeItem != null) && !(app.project.activeItem instanceof CompItem)))
		{
		}
	else
		{
				var comp = app.project.activeItem;
				var layerCollection = comp.selectedLayers;
				for (idx=0;idx<layerCollection.length;idx++)
					{
						layerCollection[idx].Effects.addProperty("Gaussian Blur").property("Blurriness").setValue(9);
					}
		}
	app.endUndoGroup();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function RadialFastBlur(){
	app.beginUndoGroup("RadialFastBlur");
	if ((app.project.activeItem == null) || ((app.project.activeItem != null) && !(app.project.activeItem instanceof CompItem)))
		{
		}
	else
		{
				var comp = app.project.activeItem;
				var layerCollection = comp.selectedLayers;
				for (idx=0;idx<layerCollection.length;idx++)
					{
						layerCollection[idx].Effects.addProperty("CC Radial Fast Blur").property("Zoom").setValue(2);
					}
		}
	app.endUndoGroup();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function ReduceInterlaceFliker(){
	app.beginUndoGroup("ReduceInterlaceFliker");
	if ((app.project.activeItem == null) || ((app.project.activeItem != null) && !(app.project.activeItem instanceof CompItem)))
		{
		}
	else
		{
				var comp = app.project.activeItem;
				var layerCollection = comp.selectedLayers;
				for (idx=0;idx<layerCollection.length;idx++)
					{
						layerCollection[idx].Effects.addProperty("Reduce Interlace Flicker").property("Softness").setValue(0.7);
					}
		}
	app.endUndoGroup();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function Level(){
	app.beginUndoGroup("Level");
	if ((app.project.activeItem == null) || ((app.project.activeItem != null) && !(app.project.activeItem instanceof CompItem)))
		{
		}
	else
		{
				var comp = app.project.activeItem;
				var layerCollection = comp.selectedLayers;
				for (idx=0;idx<layerCollection.length;idx++)
					{
						layerCollection[idx].Effects.addProperty("Levels (Individual Controls)");
					}
		}
	app.endUndoGroup();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function HueSat(){
	app.beginUndoGroup("HueSat");
	if ((app.project.activeItem == null) || ((app.project.activeItem != null) && !(app.project.activeItem instanceof CompItem)))
		{
		}
	else
		{
				var comp = app.project.activeItem;
				var layerCollection = comp.selectedLayers;
				for (idx=0;idx<layerCollection.length;idx++)
					{
						layerCollection[idx].Effects.addProperty("Hue/Saturation");
					}
		}
	app.endUndoGroup();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function Curves(){
	app.beginUndoGroup("Curves");
	if ((app.project.activeItem == null) || ((app.project.activeItem != null) && !(app.project.activeItem instanceof CompItem)))
		{
		}
	else
		{
				var comp = app.project.activeItem;
				var layerCollection = comp.selectedLayers;
				for (idx=0;idx<layerCollection.length;idx++)
					{
						layerCollection[idx].Effects.addProperty("Curves");
					}
		}
	app.endUndoGroup();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function Tint(){
	app.beginUndoGroup("Tint");
	if ((app.project.activeItem == null) || ((app.project.activeItem != null) && !(app.project.activeItem instanceof CompItem)))
		{
		}
	else
		{
				var comp = app.project.activeItem;
				var layerCollection = comp.selectedLayers;
				for (idx=0;idx<layerCollection.length;idx++)
					{
						layerCollection[idx].Effects.addProperty("Tint");
					}
		}
	app.endUndoGroup();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function Keylight(){
	app.beginUndoGroup("Keylight");
	if ((app.project.activeItem == null) || ((app.project.activeItem != null) && !(app.project.activeItem instanceof CompItem)))
		{
		}
	else
		{
				var comp = app.project.activeItem;
				var layerCollection = comp.selectedLayers;
				for (idx=0;idx<layerCollection.length;idx++)
					{
						layerCollection[idx].Effects.addProperty("Keylight (1.2)");
					}
		}
	app.endUndoGroup();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function Extract(){
	app.beginUndoGroup("Extract");
	if ((app.project.activeItem == null) || ((app.project.activeItem != null) && !(app.project.activeItem instanceof CompItem)))
		{
		}
	else
		{
				var comp = app.project.activeItem;
				var layerCollection = comp.selectedLayers;
				for (idx=0;idx<layerCollection.length;idx++)
					{
						layerCollection[idx].Effects.addProperty("Extract");
					}
		}
	app.endUndoGroup();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function Invert(){
	app.beginUndoGroup("Invert");
	if ((app.project.activeItem == null) || ((app.project.activeItem != null) && !(app.project.activeItem instanceof CompItem)))
		{
		}
	else
		{
				var comp = app.project.activeItem;
				var layerCollection = comp.selectedLayers;
				for (idx=0;idx<layerCollection.length;idx++)
					{
						layerCollection[idx].Effects.addProperty("Invert");
					}
		}
	app.endUndoGroup();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function MatteChocker(){
	app.beginUndoGroup("MatteChocker");
	if ((app.project.activeItem == null) || ((app.project.activeItem != null) && !(app.project.activeItem instanceof CompItem)))
		{
		}
	else
		{
				var comp = app.project.activeItem;
				var layerCollection = comp.selectedLayers;
				for (idx=0;idx<layerCollection.length;idx++)
					{
						layerCollection[idx].Effects.addProperty("Matte Choker");
					}
		}
	app.endUndoGroup();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function SimpleChocker(){
	app.beginUndoGroup("SimpleChocker");
	if ((app.project.activeItem == null) || ((app.project.activeItem != null) && !(app.project.activeItem instanceof CompItem)))
		{
		}
	else
		{
				var comp = app.project.activeItem;
				var layerCollection = comp.selectedLayers;
				for (idx=0;idx<layerCollection.length;idx++)
					{
						layerCollection[idx].Effects.addProperty("Simple Choker");
					}
		}
	app.endUndoGroup();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function Glow(){
	app.beginUndoGroup("Glow");
	if ((app.project.activeItem == null) || ((app.project.activeItem != null) && !(app.project.activeItem instanceof CompItem)))
		{
		}
	else
		{
				var comp = app.project.activeItem;
				var layerCollection = comp.selectedLayers;
				for (idx=0;idx<layerCollection.length;idx++)
					{
						layerCollection[idx].Effects.addProperty("Glow");
					}
		}
	app.endUndoGroup();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function Fill(){
	app.beginUndoGroup("Fill");
	if ((app.project.activeItem == null) || ((app.project.activeItem != null) && !(app.project.activeItem instanceof CompItem)))
		{
		}
	else
		{
				var comp = app.project.activeItem;
				var layerCollection = comp.selectedLayers;
				for (idx=0;idx<layerCollection.length;idx++)
					{
						layerCollection[idx].Effects.addProperty("Fill");
					}
		}
	app.endUndoGroup();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function Ramp(){
	app.beginUndoGroup("Ramp");
	if ((app.project.activeItem == null) || ((app.project.activeItem != null) && !(app.project.activeItem instanceof CompItem)))
		{
		}
	else
		{
				var comp = app.project.activeItem;
				var layerCollection = comp.selectedLayers;
				for (idx=0;idx<layerCollection.length;idx++)
					{
						layerCollection[idx].Effects.addProperty("Ramp");
					}
		}
	app.endUndoGroup();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function FractNoise(){
	app.beginUndoGroup("FractNoise");
	if ((app.project.activeItem == null) || ((app.project.activeItem != null) && !(app.project.activeItem instanceof CompItem)))
		{
		}
	else
		{
				var comp = app.project.activeItem;
				var layerCollection = comp.selectedLayers;
				for (idx=0;idx<layerCollection.length;idx++)
					{
						layerCollection[idx].Effects.addProperty("Fractal Noise");
					}
		}
	app.endUndoGroup();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function TurbulentDisplace(){
	app.beginUndoGroup("TurbulentDisplace");
	if ((app.project.activeItem == null) || ((app.project.activeItem != null) && !(app.project.activeItem instanceof CompItem)))
		{
		}
	else
		{
				var comp = app.project.activeItem;
				var layerCollection = comp.selectedLayers;
				for (idx=0;idx<layerCollection.length;idx++)
					{
						layerCollection[idx].Effects.addProperty("Turbulent Displace");
					}
		}
	app.endUndoGroup();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


 Quick_fx_palette(this); 
 }
